/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package flower.album;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;
import javax.ejb.Stateless;

/**
 *
 * @author jeff
 */
@Stateless
public class FlowerAlbum {

    private static final String[] FLOWERS = {"aster", "honeysuckle", "rose", "sunflower"};

    public byte[] getFlower(String name) throws IOException {
        URL resource = this.getClass().getResource("/flower/album/resources/"+name+".jpg");
        return getBytes(resource);
    }

    public List<byte[]> allFlowers() throws IOException {
        List<byte[]> flowers = new ArrayList<byte[]>();
        for (String flower:FLOWERS) {
            URL resource = this.getClass().getResource("/flower/album/resources/"+flower+".jpg");
            flowers.add(getBytes(resource));
        }
        return flowers;
    }

    private byte[] getBytes(URL resource) throws IOException {
        InputStream in = resource.openStream();
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        byte[] buf = new byte[1024];
        for(int read; (read = in.read(buf)) != -1;) {
            bos.write(buf, 0, read);
        }
        return bos.toByteArray();
    }

}
